-- name: [CS] \\#32BCC6\\Triple\\#FF273E\\ Baka\\#FFBF2D\\ Pack
-- description: The Cheerful Vocaloid, \\#32BCC6\\Hatsune Miku\\#FFFFFF\\, her eager but also mischievous friend, \\#FF273E\\Kasane Teto\\#FFFFFF\\, and the most subborn of the trio, \\#FFBF2D\\Akita Neru\\#FFFFFF\\, all arrive in the low poly world of the Mushroom Kingdom, will the singing trio be able to grab all the stars and save the Princess from the Koopa Clan leader, Bowser?\n\n\\\#FCBA03\\WARNING: This mod might have a person who has Blue Hair, Blue Tie, hiding in your Wi-Fi!\n\n\\\#FFFFFF\\Made by VioletArts and Chalz

local TEXT_MOD_NAME = "Triple Baka Pack"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MIKU_MODEL = smlua_model_util_get_id("miku_violet_geo")
local E_BRAZILMIKU_MODEL = smlua_model_util_get_id("brazilmiku_violet_geo")
local E_MARIOMIKU_MODEL = smlua_model_util_get_id("mariomiku_violet_geo")
local E_MESMIKU_MODEL = smlua_model_util_get_id("mesmiku_violet_geo")
local E_SONICMIKU_MODEL = smlua_model_util_get_id("sonicmiku_violet_geo")

local E_TETO_MODEL = smlua_model_util_get_id("teto_violet_geo")
local E_SYNTHTETO_MODEL = smlua_model_util_get_id("synthteto_violet_geo")
local E_MESTETO_MODEL = smlua_model_util_get_id("mesteto_violet_geo")
local E_LUIGITETO_MODEL = smlua_model_util_get_id("luigiteto_violet_geo")
local E_OVERRIDETETO_MODEL = smlua_model_util_get_id("overrideteto_violet_geo")

local E_AKITA_MODEL = smlua_model_util_get_id("akita_violet_geo")
local E_WARIONERU_MODEL = smlua_model_util_get_id("warioakita_violet_geo")

local TEX_MIKU_ICON = get_texture_info("miku_violet_icon")
local TEX_TETO_ICON = get_texture_info("teto_violet_icon")
local TEX_AKITA_ICON = get_texture_info("akita_violet_icon")

local VOICETABLE_MIKU = {
    [CHAR_SOUND_OKEY_DOKEY] = 'MikuOkieDokie.ogg',
    [CHAR_SOUND_ATTACKED] = 'MikuAttacked.ogg',
    [CHAR_SOUND_COUGHING3] = 'MikuCough.ogg',
    [CHAR_SOUND_DOH] = 'MikuDoh.ogg',
    [CHAR_SOUND_DROWNING] = 'MikuDrown.ogg',
    [CHAR_SOUND_DYING] = 'MikuDead.ogg',
    [CHAR_SOUND_EEUH] = 'MikuEeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'MikuWah.ogg',
    [CHAR_SOUND_HAHA] = 'MikuHaha.ogg',
    [CHAR_SOUND_HAHA_2] = 'MikuHaha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'MikuSugoi.ogg',
    [CHAR_SOUND_HOOHOO] = 'MikuHooHoo.ogg',
    [CHAR_SOUND_HRMM] = 'MikuGrab.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'MikuTired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'MikuLetsDoThis.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'MikuOhNo.ogg',
    [CHAR_SOUND_ON_FIRE] = 'MikuBurning.ogg',
    [CHAR_SOUND_OOOF] = 'MikuOof.ogg',
    [CHAR_SOUND_OOOF2] = 'MikuOof.ogg',
    [CHAR_SOUND_PANTING] = 'MikuPanting.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'MikuPanting.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'MikuHoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'MikuWah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'MikuYah.ogg',
    [CHAR_SOUND_SNORING1] = 'MikuSnore1.ogg',
    [CHAR_SOUND_SNORING2] = 'MikuSnore2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'MikuBowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'MikuBoing.ogg',
    [CHAR_SOUND_UH] = 'MikuUh.ogg',
    [CHAR_SOUND_UH2] = 'MikuUh.ogg',
    [CHAR_SOUND_UH2_2] = 'MikuUh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'MikuYell.ogg',
    [CHAR_SOUND_WHOA] = 'MikuWoah.ogg',
    [CHAR_SOUND_YAHOO] = 'MikuYahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'MikuYahoo.ogg', 'MikuWaha.ogg', 'MikuYippee.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'MikuYah.ogg', 'MikuWah.ogg', 'MikuHoo.ogg'},
    [CHAR_SOUND_YAWNING] = 'MikuYawn.ogg',
}

local VOICETABLE_TETO = {
    [CHAR_SOUND_OKEY_DOKEY] = 'TetoOkieDokie.ogg',
    [CHAR_SOUND_ATTACKED] = 'TetoAttacked.ogg',
    [CHAR_SOUND_COUGHING3] = 'TetoCough.ogg',
    [CHAR_SOUND_DOH] = 'TetoDoh.ogg',
    [CHAR_SOUND_DROWNING] = 'TetoDrown.ogg',
    [CHAR_SOUND_DYING] = 'TetoDead.ogg',
    [CHAR_SOUND_EEUH] = 'TetoEeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'TetoWah.ogg',
    [CHAR_SOUND_HAHA] = 'TetoHaha.ogg',
    [CHAR_SOUND_HAHA_2] = 'TetoHaha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'TetoHereWeGo.ogg',
    [CHAR_SOUND_HOOHOO] = 'TetoHooHoo.ogg',
    [CHAR_SOUND_HRMM] = 'TetoGrab.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'TetoTired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'TetoLetsDoThis.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'TetoOhNo.ogg',
    [CHAR_SOUND_ON_FIRE] = 'TetoBurning.ogg',
    [CHAR_SOUND_OOOF] = 'TetoOof.ogg',
    [CHAR_SOUND_OOOF2] = 'TetoOof.ogg',
    [CHAR_SOUND_PANTING] = 'TetoPanting.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'TetoPanting.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'TetoHoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'TetoWah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'TetoYah.ogg',
    [CHAR_SOUND_SNORING1] = 'TetoSnore1.ogg',
    [CHAR_SOUND_SNORING2] = 'TetoSnore2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'TetoBowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'TetoBoing.ogg',
    [CHAR_SOUND_UH] = 'TetoUh.ogg',
    [CHAR_SOUND_UH2] = 'TetoUh.ogg',
    [CHAR_SOUND_UH2_2] = 'TetoUh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'TetoYell.ogg',
    [CHAR_SOUND_WHOA] = 'TetoWoah.ogg',
    [CHAR_SOUND_YAHOO] = 'TetoYahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'TetoYahoo.ogg', 'TetoWaha.ogg', 'TetoYippee.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'TetoYah.ogg', 'TetoWah.ogg', 'TetoHoo.ogg'},
    [CHAR_SOUND_YAWNING] = 'TetoYawn.ogg',
}

local VOICETABLE_AKITA = {
    [CHAR_SOUND_OKEY_DOKEY] = 'NeruOkieDokie.ogg',
    [CHAR_SOUND_ATTACKED] = 'NeruAttacked.ogg',
    [CHAR_SOUND_COUGHING3] = 'NeruCough.ogg',
    [CHAR_SOUND_DOH] = 'NeruDoh.ogg',
    [CHAR_SOUND_DROWNING] = 'NeruDrown.ogg',
    [CHAR_SOUND_DYING] = 'NeruDead.ogg',
    [CHAR_SOUND_EEUH] = 'NeruEeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'NeruWah.ogg',
    [CHAR_SOUND_HAHA] = 'NeruHaha.ogg',
    [CHAR_SOUND_HAHA_2] = 'NeruHaha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'NeruHereWeGo.ogg',
    [CHAR_SOUND_HOOHOO] = 'NeruHooHoo.ogg',
    [CHAR_SOUND_HRMM] = 'NeruGrab.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'NeruTired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'NeruLetsDoThis.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'NeruOhNo.ogg',
    [CHAR_SOUND_ON_FIRE] = 'NeruBurning.ogg',
    [CHAR_SOUND_OOOF] = 'NeruOof.ogg',
    [CHAR_SOUND_OOOF2] = 'NeruOof.ogg',
    [CHAR_SOUND_PANTING] = 'NeruPanting.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'NeruPanting.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'NeruHoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'NeruWah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'NeruYah.ogg',
    [CHAR_SOUND_SNORING1] = 'NeruSnore1.ogg',
    [CHAR_SOUND_SNORING2] = 'NeruSnore2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'NeruBowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'NeruBoing.ogg',
    [CHAR_SOUND_UH] = 'NeruUh.ogg',
    [CHAR_SOUND_UH2] = 'NeruUh.ogg',
    [CHAR_SOUND_UH2_2] = 'NeruUh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'NeruYell.ogg',
    [CHAR_SOUND_WHOA] = 'NeruWoah.ogg',
    [CHAR_SOUND_YAHOO] = 'NeruYahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'NeruYahoo.ogg', 'NeruWaha.ogg', 'NeruYippee.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'NeruYah.ogg', 'NeruWah.ogg', 'NeruHoo.ogg'},
    [CHAR_SOUND_YAWNING] = 'NeruYawn.ogg',
}

local MIKU_PALETTE = {
    [PANTS] = "233139",
    [SHIRT] = "BBBFCA",
    [GLOVES] = "233139",
    [SHOES] = "233139",
    [HAIR] = "32BCC6",
    [SKIN] = "FFBD97",
    [CAP] = "32BCC6",
    [EMBLEM] = "32BCC6"
}

local BRAZILMIKU_PALETTE = {
    [PANTS] = "304161",
    [SHIRT] = "FFB000",
    [GLOVES] = "FFFFFF",
    [SHOES] = "FFFFFF",
    [HAIR] = "32BCC6",
    [SKIN] = "FE8C50",
    [CAP] = "3BAD32",
    [EMBLEM] = "F2D700"
}

local MARIOMIKU_PALETTE = {
    [PANTS] = "0000FF",
    [SHIRT] = "FF0000",
    [GLOVES] = "FFFFFF",
    [SHOES] = "721C0E",
    [HAIR] = "32BCC6",
    [SKIN] = "FFBD97",
    [CAP] = "FF0000",
    [EMBLEM] = "FF0000"
}

local MESMIKU_PALETTE = {
    [PANTS] = "FFFFFF",
    [SHIRT] = "3250FF",
    [GLOVES] = "FFD300",
    [SHOES] = "FF2828",
    [HAIR] = "32BCC6",
    [SKIN] = "FFBD97",
    [CAP] = "FFFFFF",
    [EMBLEM] = "FF2828"
}

local SONICMIKU_PALETTE = {
    [PANTS] = "0F46FF",
    [SHIRT] = "0F46FF",
    [GLOVES] = "FFFFFF",
    [SHOES] = "FF0000",
    [HAIR] = "32BCC6",
    [SKIN] = "FFBD97",
    [CAP] = "32BCC6",
    [EMBLEM] = "FFFFFF"
}

local TETO_PALETTE = {
    [PANTS] = "374155",
    [SHIRT] = "374155",
    [GLOVES] = "374155",
    [SHOES] = "14171F",
    [HAIR] = "FF273E",
    [SKIN] = "FED7A4",
    [CAP] = "FF273E",
    [EMBLEM] = "FF2D4B"
}

local SYNTHTETO_PALETTE = {
    [PANTS] = "D1D1CB",
    [SHIRT] = "D1D1CB",
    [GLOVES] = "374155",
    [SHOES] = "14171F",
    [HAIR] = "FF273E",
    [SKIN] = "FED7A4",
    [CAP] = "FF273E",
    [EMBLEM] = "FF2D4B"
}

local MESTETO_PALETTE = {
    [PANTS] = "FF0023",
    [SHIRT] = "FFFFFF",
    [GLOVES] = "FFEB1A",
    [SHOES] = "14171F",
    [HAIR] = "FF273E",
    [SKIN] = "FED7A4",
    [CAP] = "FF0023",
    [EMBLEM] = "3CA0FF"
}

local LUIGITETO_PALETTE = {
    [PANTS] = "0000FF",
    [SHIRT] = "00FF00",
    [GLOVES] = "FFFFFF",
    [SHOES] = "721C0E",
    [HAIR] = "FF273E",
    [SKIN] = "FED7A4",
    [CAP] = "00FF00",
    [EMBLEM] = "00FF00"
}

local OVERRIDETETO_PALETTE = {
    [PANTS] = "1B1B1B",
    [SHIRT] = "6E7466",
    [GLOVES] = "FFFFFF",
    [SHOES] = "FF273E",
    [HAIR] = "FF273E",
    [SKIN] = "FED7A4",
    [CAP] = "1B1B1B",
    [EMBLEM] = "FFFFFF"
}

local AKITA_PALETTE = {
    [PANTS] = "353535",
    [SHIRT] = "838383",
    [GLOVES] = "353535",
    [SHOES] = "353535",
    [HAIR] = "FFBF2D",
    [SKIN] = "FFBD97",
    [CAP] = "FFBF2D",
    [EMBLEM] = "FFBF2D"
}

local WARIONERU_PALETTE = {
    [PANTS] = "7B00BD",
    [SHIRT] = "FFC100",
    [GLOVES] = "FFFFFF",
    [SHOES] = "0E721C",
    [HAIR] = "FFBF2D",
    [SKIN] = "FFBD97",
    [CAP] = "FFC100",
    [EMBLEM] = "FFC100"
}

local MIKU_CAPMODELS = {
    normal = smlua_model_util_get_id("miku_violet_cap_geo"),
    wing = smlua_model_util_get_id("miku_violet_cap_wing_geo"),
    metal = smlua_model_util_get_id("miku_violet_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("miku_violet_cap_metal_wing_geo"),
}

local TETO_CAPMODELS = {
    normal = smlua_model_util_get_id("teto_violet_cap_geo"),
    wing = smlua_model_util_get_id("teto_violet_cap_wing_geo"),
    metal = smlua_model_util_get_id("teto_violet_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("teto_violet_cap_metal_wing_geo"),
}

local AKITA_CAPMODELS = {
    normal = smlua_model_util_get_id("akita_violet_cap_geo"),
    wing = smlua_model_util_get_id("akita_violet_cap_wing_geo"),
    metal = smlua_model_util_get_id("akita_violet_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("akita_violet_cap_metal_wing_geo"),
}

local HEALTH_METER_MIKU = {
    label = {
        left = get_texture_info("MikuLeft"),
        right = get_texture_info("MikuRight"),
    },
    pie = {
        [1] = get_texture_info("Miku-1"),
        [2] = get_texture_info("Miku-2"),
        [3] = get_texture_info("Miku-3"),
        [4] = get_texture_info("Miku-4"),
        [5] = get_texture_info("Miku-5"),
        [6] = get_texture_info("Miku-6"),
        [7] = get_texture_info("Miku-7"),
        [8] = get_texture_info("Miku-8"),
    }
}

local charSelectLoaded = false
local function on_character_select_load()
    CT_MIKU = _G.charSelect.character_add("Hatsune Miku", {"The Cheerful Vocaloid, Hatsune Miku,", "makes her debut on the", "big stage, but this time", "in a bit of low poly", "form, can Miku make her", "way to super stardom and", "defeat Bowser?"}, "Violet", {r = 67, g = 185, b = 255}, E_MIKU_MODEL, CT_TOAD, TEX_MIKU_ICON)
    _G.charSelect.character_add_voice(E_MIKU_MODEL, VOICETABLE_MIKU)
    _G.charSelect.character_add_palette_preset(E_MIKU_MODEL, MIKU_PALETTE)
    _G.charSelect.character_add_caps(E_MIKU_MODEL, MIKU_CAPMODELS)
    _G.charSelect.character_add_health_meter(CT_MIKU, HEALTH_METER_MIKU)
    
    _G.charSelect.character_add_costume(CT_MIKU, "Brazilian Miku", nil, "Violet", nil, E_BRAZILMIKU_MODEL, CT_TOAD, TEX_MIKU_ICON, nil, nil)
    _G.charSelect.character_add_voice(E_BRAZILMIKU_MODEL, VOICETABLE_MIKU)
    _G.charSelect.character_add_palette_preset(E_BRAZILMIKU_MODEL, BRAZILMIKU_PALETTE)
    _G.charSelect.character_add_caps(E_BRAZILMIKU_MODEL, MIKU_CAPMODELS)

    _G.charSelect.character_add_costume(CT_MIKU, "Mario Miku", nil, "Violet", nil, E_MARIOMIKU_MODEL, CT_MARIO, TEX_MIKU_ICON, nil, nil)
    _G.charSelect.character_add_voice(E_MARIOMIKU_MODEL, VOICETABLE_MIKU)
    _G.charSelect.character_add_palette_preset(E_MARIOMIKU_MODEL, MARIOMIKU_PALETTE)

    _G.charSelect.character_add_costume(CT_MIKU, "Mesmerizer Miku", nil, "Violet", nil, E_MESMIKU_MODEL, CT_TOAD, TEX_MIKU_ICON, nil, nil)
    _G.charSelect.character_add_voice(E_MESMIKU_MODEL, VOICETABLE_MIKU)
    _G.charSelect.character_add_palette_preset(E_MESMIKU_MODEL, MESMIKU_PALETTE)
    _G.charSelect.character_add_caps(E_MESMIKU_MODEL, MIKU_CAPMODELS)

    _G.charSelect.character_add_costume(CT_MIKU, "Sonic Miku", nil, "Violet", nil, E_SONICMIKU_MODEL, CT_TOAD, TEX_MIKU_ICON, nil, nil)
    _G.charSelect.character_add_voice(E_SONICMIKU_MODEL, VOICETABLE_MIKU)
    _G.charSelect.character_add_palette_preset(E_SONICMIKU_MODEL, SONICMIKU_PALETTE)
    _G.charSelect.character_add_caps(E_SONICMIKU_MODEL, MIKU_CAPMODELS)

    CT_TETO = _G.charSelect.character_add("Kasane Teto", {"Kasane Teto, the utaloid singer", "is here! With her red twin", "drill hair, she is ready", "to sing with Hatsune Miku", "in this low poly world!"}, "Violet", {r = 255, g = 39, b = 62}, E_TETO_MODEL, CT_TOAD, TEX_TETO_ICON)
    _G.charSelect.character_add_palette_preset(E_TETO_MODEL, TETO_PALETTE)
    _G.charSelect.character_add_voice(E_TETO_MODEL, VOICETABLE_TETO)
    _G.charSelect.character_add_caps(E_TETO_MODEL, TETO_CAPMODELS)
    _G.charSelect.character_add_health_meter(CT_TETO, HEALTH_METER_MIKU)

    _G.charSelect.character_add_costume(CT_TETO, "SynthV Teto", nil, "Violet", nil, E_SYNTHTETO_MODEL, CT_TOAD, TEX_TETO_ICON, nil, nil)
    _G.charSelect.character_add_palette_preset(E_SYNTHTETO_MODEL, SYNTHTETO_PALETTE)
    _G.charSelect.character_add_voice(E_SYNTHTETO_MODEL, VOICETABLE_TETO)
    _G.charSelect.character_add_caps(E_SYNTHTETO_MODEL, TETO_CAPMODELS)

    _G.charSelect.character_add_costume(CT_TETO, "Mesmerizer Teto", nil, "Violet", nil, E_MESTETO_MODEL, CT_TOAD, TEX_TETO_ICON, nil, nil)
    _G.charSelect.character_add_palette_preset(E_MESTETO_MODEL, MESTETO_PALETTE)
    _G.charSelect.character_add_voice(E_MESTETO_MODEL, VOICETABLE_TETO)
    _G.charSelect.character_add_caps(E_MESTETO_MODEL, TETO_CAPMODELS)

    _G.charSelect.character_add_costume(CT_TETO, "Luigi Teto", nil, "Violet", nil, E_LUIGITETO_MODEL, CT_LUIGI, TEX_TETO_ICON, nil, nil)
    _G.charSelect.character_add_palette_preset(E_LUIGITETO_MODEL, LUIGITETO_PALETTE)
    _G.charSelect.character_add_voice(E_LUIGITETO_MODEL, VOICETABLE_TETO)

    _G.charSelect.character_add_costume(CT_TETO, "Override Teto", nil, "Violet", nil, E_OVERRIDETETO_MODEL, CT_TOAD, TEX_TETO_ICON, nil, nil)
    _G.charSelect.character_add_palette_preset(E_OVERRIDETETO_MODEL, OVERRIDETETO_PALETTE)
    _G.charSelect.character_add_voice(E_OVERRIDETETO_MODEL, VOICETABLE_TETO)
    _G.charSelect.character_add_caps(E_OVERRIDETETO_MODEL, TETO_CAPMODELS)

    CT_AKITA = _G.charSelect.character_add("Akita Neru", {"The most stubborn of the trio,", "Akita Neru, the popular fanloid,", "makes her debut, even with one", "ponytail and constantly being on", "her phone, Neru is ready to", "rock with her 'baka' friends"}, "Violet", {r = 252, g = 186, b = 3}, E_AKITA_MODEL, CT_TOAD, TEX_AKITA_ICON)
    _G.charSelect.character_add_voice(E_AKITA_MODEL, VOICETABLE_AKITA)
    _G.charSelect.character_add_palette_preset(E_AKITA_MODEL, AKITA_PALETTE)
    _G.charSelect.character_add_caps(E_AKITA_MODEL, AKITA_CAPMODELS)
    _G.charSelect.character_add_health_meter(CT_AKITA, HEALTH_METER_MIKU)

    _G.charSelect.character_add_costume(CT_AKITA, "Wario Neru", nil, "Violet", nil, E_WARIONERU_MODEL, CT_WARIO, TEX_AKITA_ICON, nil, nil)
    _G.charSelect.character_add_voice(E_WARIONERU_MODEL, VOICETABLE_AKITA)
    _G.charSelect.character_add_palette_preset(E_WARIONERU_MODEL, WARIONERU_PALETTE)

    if _G.charSelect.credit_add then
        _G.charSelect.credit_add(TEXT_MOD_NAME, "VioletArts", "Pack Creator")
        _G.charSelect.credit_add(TEXT_MOD_NAME, "chalz", "Miku/Teto/Akita Voicelines")
        _G.charSelect.credit_add(TEXT_MOD_NAME, "chalz", "Miku SM64 Music")
        _G.charSelect.credit_add(TEXT_MOD_NAME, "King The Memer", "End Scene Code")
        _G.charSelect.credit_add(TEXT_MOD_NAME, "ManIsCat2", "Triple Baka Music & Dialog Code")
    end

    charSelectLoaded = true
end

local function mario_update(m)
    local MikuEyeUpActs = {
        --[act] = true,
        [ACT_GETTING_BLOWN] = true,
        [ACT_THROWN_FORWARD] = true,
        [ACT_THROWN_BACKWARD] = true,
        [ACT_SHOCKED] = true,
        [ACT_SOFT_BACKWARD_GROUND_KB] = m.actionArg > 0,
        [ACT_BACKWARD_GROUND_KB] = m.actionArg > 0,
        [ACT_HARD_BACKWARD_GROUND_KB] = m.actionArg > 0,
        [ACT_BACKWARD_AIR_KB] = m.actionArg > 0,
        [ACT_HARD_BACKWARD_AIR_KB] = m.actionArg > 0,
        [ACT_BACKWARD_WATER_KB] = m.actionArg > 0,
        [ACT_SOFT_FORWARD_GROUND_KB] = m.actionArg > 0,
        [ACT_FORWARD_GROUND_KB] = m.actionArg > 0,
        [ACT_HARD_FORWARD_GROUND_KB] = m.actionArg > 0,
        [ACT_FORWARD_AIR_KB] = m.actionArg > 0,
        [ACT_HARD_FORWARD_AIR_KB] = m.actionArg > 0,
        [ACT_FORWARD_WATER_KB] = m.actionArg > 0,
    }
    if _G.charSelect.character_get_current_number() == CT_MIKU then
        if MikuEyeUpActs[m.action] then
            m.marioBodyState.eyeState = MARIO_EYES_LOOK_UP
        end

        if m.marioBodyState.handState == MARIO_HAND_PEACE_SIGN then
            m.marioBodyState.eyeState = MARIO_EYES_LOOK_DOWN
        end
    elseif _G.charSelect.character_get_current_number() == CT_TETO then
        if MikuEyeUpActs[m.action] then
            m.marioBodyState.eyeState = MARIO_EYES_LOOK_UP
        end

        if m.marioBodyState.handState == MARIO_HAND_PEACE_SIGN then
            m.marioBodyState.eyeState = MARIO_EYES_LOOK_DOWN
        end
    elseif _G.charSelect.character_get_current_number() == CT_AKITA then
        if MikuEyeUpActs[m.action] then
            m.marioBodyState.eyeState = MARIO_EYES_LOOK_UP
        end
    end
    if not charSelectLoaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MIKU then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_TETO then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_AKITA then return _G.charSelect.voice.snore(m) end
end
 
local function on_character_sound(m, sound)
    if not charSelectLoaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MIKU then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_TETO then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_AKITA then return _G.charSelect.voice.sound(m, sound) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, mario_update)